<?php

App::uses('EvNewsletterSignupsAppModel', 'EvNewsletterSignups.Model');

class Signup extends EvNewsletterSignupsAppModel {

	/**
	 * validation rules
	 */
	public $validate = array(
		'email' => array(
			'required' => array(
				'rule' => 'notBlank',
				'message' => 'Email cannot be left blank'
			),
			'email' => array(
				'rule' => 'email',
				'message' => 'You must enter a valid email address'
			),
			'unique' => array(
				'rule' => 'isUnique',
				'message' => 'A user with that email address already exists'
			)
		)
	);

	/**
	 * afterFind callback
	 * decode the extras if set
	 *
	 */
	public function afterFind($results, $primary = false) {
		$results = parent::afterFind($results, $primary);

		foreach ($results as $key => $item) {
			if (! empty($item['Signup']['extras'])) {
				$results[$key]['Signup']['extras'] = json_decode($item['Signup']['extras'], true);
			}
		}

		return $results;
	}
}
