# EvNewsletterSignups

## Installation

Simply add EvNewsletterSignups to the `install.php` file within the Config directory and run `Console/cake installer core` once you have added all the other plugins you will need.

If this has already been run, simply run `Console/cake installer plugin EvNewsletterSignups`.

The installer will automatically setup the database tables and create a link in the admin menu to download the list of sign ups.

## How it works

The plugin works by posting the signup form to the same page and having a component included on that same page. The component then runs on the built in callback methods to automatically check the post variables and sign the user up or display error if needed.

The plugin only requires email as default but can handle extra fields which can be defined within the config file. These will be json'd and stored in a text field on the database row. Upon creating a CSV export, these are decoded and then placed into the CSV along with the email.

## Setup

Once the installer is run, you can setup an extra fields within the config, these are optional. If you do require extra fields, these can be defined in the standard format used throughout the CMS.

	'extraFields' => array(
		'name' => array(
			'type' => 'string',
			'label' => 'Name',
			'class' => 'class-name'
		)
	)	
	
Within the template include the element bundled with the plugin to display the signup form.

	<?=$this->element('EvNewsletterSignups.signup-form')?>
	
Within the controller you need to add the component and the helper to their respective arrays, this can be done by overriding the AppControllers Constructor to make it available on every page.

	public function __construct($request = null, $response = null) {
		if (CakePlugin::loaded('EvNewsletterSignups')) {
			$this->components[] = 'EvNewsletterSignups.Signups';
			$this->helpers[] = 'EvNewsletterSignups.Signups';
		}
		
		parent::__construct($request, $response);
	}
	
Within the config, you can also customise the flash success / fail message that is displayed.		